<?php

namespace App\Components\LeadSource;

use App\Models\LeadSource\LeadSource;
use Livewire\Attributes\Lazy;
use Livewire\Component;
use Livewire\WithPagination;

#[Lazy]
class LeadSourceList extends Component {
    use WithPagination;

    public $search = '';
    public $sortColumn = 'display_name';
    public $sortDirection = 'asc';
    public $perPage = 10;

    public function placeholder() {
        return <<<'HTML'
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-body">
                        <div class="placeholder placeholder-wave w-100"></div>
                        <div class="placeholder placeholder-wave w-100"></div>
                        <div class="placeholder placeholder-wave w-100"></div>
                        <div class="placeholder placeholder-wave w-100"></div>
                        <div class="placeholder placeholder-wave w-75"></div>
                        <div class="placeholder placeholder-wave w-50"></div>
                    </div>
                </div>
            </div>
        </div>
        HTML;

    }

    public function render() {
        $sources = LeadSource::query();

        if($this->search) {
            $sources->where('display_name', 'like', '%'.$this->search.'%');
        }

        $sources = $sources->paginate($this->perPage);
        return view('components.lead-source.lead-source-list', compact('sources'));
    }
}
